package objdbTest;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.TypedQuery;
import javax.persistence.Version;

@Entity
public class Singleton {

	public static Singleton getInstance(EntityManager em) {
		Singleton c = em.find(Singleton.class, "1");
		if (c == null) {
			c = new Singleton();
			em.persist(c);
		}
		return c;
	}

	@Id
	protected String id = "1";

	@SuppressWarnings("unused")
	// used by JPA
	@Version
	private int version;

	@Basic
	protected java.lang.Integer lastInstance;


	public void generateItems(EntityManager em, int howMany) {
		if (lastInstance == null) {
			lastInstance = 0;
		}
		int endCnt = lastInstance + howMany;
		int startCnt = lastInstance;
		while (endCnt > startCnt) {
			startCnt++;
			Item item = new Item(this, startCnt);
			em.persist(item);
			lastInstance = startCnt;
		}
	}

	public long howManyItemsExist(EntityManager em) {
		TypedQuery<Long> q = em.createQuery("SELECT COUNT(x) FROM Item x", Long.class);
		try {
			return q.getSingleResult();
		} catch (javax.persistence.NoResultException ex) {
			return -1;
		}
	}
}
