package objdbTest;

import java.io.IOException;
import java.io.PrintWriter;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;


/**
 * Servlet implementation class TestServlet
 */
@WebServlet("/TestServlet")
public class TestServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	
	private static final int AMOUNT = 1000;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public TestServlet() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		long newTotal = addItems(AMOUNT);
		if(-1 == newTotal) {
			outputError(response);
		}
		else {
			outputTotal(response, newTotal);
		}
	}
	
	

	private void outputTotal(HttpServletResponse response, long newTotal) {
		try {
			PrintWriter out = response.getWriter();
			out.println(
					"<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">" +
					"<html><head>" +
					"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">"+
					"<title>Result</title>" +
					"</head>" +   
					"<body>" + 
						"<h3>Added " + AMOUNT + " and got " + newTotal + "</h3>" +
						"<a href=\"TestServlet\">Add another " + AMOUNT + "</a>" +
					"</body>" +
					"</html>");
			out.flush();
		} catch (IOException e) {
			try {
				response.sendError(500, "Cannot be print writer");
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		
	}

	private void outputError(HttpServletResponse response) {try {
		PrintWriter out = response.getWriter();
		out.println(
				"<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">" +
				"<html><head>" +
				"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">"+
				"<title>Result</title>" +
				"</head>" +   
				"<body>" + 
					"<h3>Oh No Something went wrong - look at the logs</h3>" +
					"<a href=\"TestServlet\">Try again</a>" +
				"</body>" +
				"</html>");
		out.flush();
	} catch (IOException e) {
		try {
			response.sendError(500, "Cannot be print writer");
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}
	}

	private long addItems(int howMany) {
		long newTotal = -1;
		try {
			InitialContext context = new InitialContext();
			javax.transaction.UserTransaction tx = (javax.transaction.UserTransaction) context
					.lookup("java:comp/UserTransaction");
			tx.begin();
			SLSBObjDbRemote bean = (SLSBObjDbRemote) context
					.lookup("SLSBObjDb");
			long oldAmount = bean.countItems();
			bean.addItems(howMany);
			newTotal = bean.countItems();
			if(newTotal < (howMany+oldAmount)) {
				System.err.println("Only found " + newTotal + " items expected " + (howMany + oldAmount));
			}
			tx.commit();
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (NotSupportedException e) {
			e.printStackTrace();
		} catch (SystemException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IllegalStateException e) {
			e.printStackTrace();
		} catch (RollbackException e) {
			e.printStackTrace();
		} catch (HeuristicMixedException e) {
			e.printStackTrace();
		} catch (HeuristicRollbackException e) {
			e.printStackTrace();
		} finally {
		}
		return newTotal;
	}

}
